using UnityEngine;
using UnityEngine.Events;

namespace Modern
{
  public class AmmoBehaviourV1_3 : MonoBehaviour
  {
      public bool Auto;
      public float FireRate;
      public int MaxAmmo = 999999;
      public int TrueMaxAmmo;
      public int CurrentAmmo;
      public int ViewID = 0;
      public int SwitchID = 2;
      public int Shots = 1;
      public FirearmBehaviour Fire;
      public AudioSource ReloadSound;
      public AudioSource NOSound;
      public AudioSource SwitchSound;
      float Counter = 0f;

      void Awake()                                                                                               //<-- Audio
      {
        ReloadSound = gameObject.AddComponent<AudioSource>();
        NOSound = gameObject.AddComponent<AudioSource>();
        SwitchSound = gameObject.AddComponent<AudioSource>();

        ReloadSound.volume = 4f;
        ReloadSound.minDistance = 15f;
        ReloadSound.spatialBlend = 1f;
        ReloadSound.dopplerLevel = 0.0f;

        NOSound.volume = 2.5f;
        NOSound.minDistance = 15f;
        NOSound.spatialBlend = 1f;
        NOSound.dopplerLevel = 0.0f;
        NOSound.clip = ModAPI.LoadSound("Sounds/Featured/no sound.mp3");

        SwitchSound.volume = 2f;
        SwitchSound.minDistance = 15f;
        SwitchSound.spatialBlend = 1f;
        SwitchSound.dopplerLevel = 0.0f;
        SwitchSound.clip = ModAPI.LoadSound("Sounds/Featured/switch sound.mp3");
      }

      private void Start()
      {
              Auto = gameObject.GetComponent<FirearmBehaviour>().Automatic;
              FireRate = gameObject.GetComponent<FirearmBehaviour>().AutomaticFireInterval;
              gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = true;

              if (TrueMaxAmmo <= 0)
              {
                  TrueMaxAmmo = 30;
              }
              if (FireRate <= 0)
              {
                  FireRate = 0.1f;
              }
              CurrentAmmo = MaxAmmo;
              Counter = FireRate;
              ViewID = 0;
              Shots = 1;
              Buttons();
      }

      void Buttons()                                                                                            //<-- Menu Buttons
      {
        if (SwitchID == 2)
        {
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", () =>
        {
          ModAPI.Notify("Switched to <color=green>Auto");
          SwitchSound.Play();

          Auto = true;
        }));
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=white>Semi-Auto</color>", "<color=white>Switch shooting mode to semi-auto.", () =>
        {
          ModAPI.Notify("Switched to <color=#FABF7E>Semi-auto");
          SwitchSound.Play();

          Auto = false;
        }));
        }
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("limited ammo", "<color=red>Limited Ammo", "<color=red>Makes them limited. To make it with each gun on spawn Press [L]", () =>
          {
              if (CurrentAmmo > TrueMaxAmmo)
              {
              CurrentAmmo = TrueMaxAmmo;
              }
              if (CurrentAmmo <= TrueMaxAmmo)
              {
              CurrentAmmo = CurrentAmmo;
              }
              ModAPI.Notify("Infinity Ammo <color=red> OFF");
              ViewID = 1;
          }));
          this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("limited ammo hidden", "<color=white>Limited Ammo HIDE", "<color=white>The same limited amount of ammo only without pop-up messages. Useful if you are shooting a video or film. To make it with each gun on spawn Press [H]", () =>
            {
                if (CurrentAmmo > TrueMaxAmmo)
                {
                CurrentAmmo = TrueMaxAmmo;
                }
                if (CurrentAmmo <= TrueMaxAmmo)
                {
                CurrentAmmo = CurrentAmmo;
                }
                ModAPI.Notify("Infinity Ammo <color=red> OFF");
                ViewID = 0;
            }));
          this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("ammo int", "<color=red>Show Ammo", "<color=red>Shows your current ammo.", () =>
            {
                if (CurrentAmmo <= TrueMaxAmmo & CurrentAmmo > 0)
                {
                  ModAPI.Notify("<color=green>Ammo:</color><color=black>s</color>" + CurrentAmmo + "<color=black>s</color>/<color=black>s</color>" + TrueMaxAmmo);
                }
                if (CurrentAmmo > TrueMaxAmmo)
                {
                  ModAPI.Notify("<color=green>Ammo:</color><color=black>s</color>" + TrueMaxAmmo + "<color=black>s</color>/<color=black>s</color>" + TrueMaxAmmo);
                }
                if (CurrentAmmo == 0)
                {
                  ModAPI.Notify("<color=red>NO Ammo");
                }
            }));
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("ammo reload", "<color=white>Reload Ammo", "<color=white>Reload if no ammo. To reload each gun on spawn Press [R]", () =>
          {
              if (CurrentAmmo <= TrueMaxAmmo)
              {
              CurrentAmmo = TrueMaxAmmo;
              }
              if (CurrentAmmo > TrueMaxAmmo)
              {
              CurrentAmmo = MaxAmmo;
              }
              ModAPI.Notify("<color=#FABF7E>Reloaded");

              ReloadSound.Play();
          }));
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("infinity ammo", "<color=red>Infinity Ammo", "<color=red>Makes them infinity. To make it with each gun on spawn Press [I]", () =>
          {
              CurrentAmmo = MaxAmmo;
              ModAPI.Notify("Infinity Ammo<color=green> ON");
          }));
      }

      void Update()
      {
        if (CurrentAmmo < 1)
        {
            CurrentAmmo = 0;
        }
        if (Input.GetKeyDown (KeyCode.R))
        {
          if (CurrentAmmo <= TrueMaxAmmo)
          {
          CurrentAmmo = TrueMaxAmmo;
          }
          if (CurrentAmmo > TrueMaxAmmo)
          {
          CurrentAmmo = MaxAmmo;
          }
          ModAPI.Notify("<color=#FABF7E>Reloaded");
          ReloadSound.Play();
        }

        if (Input.GetKeyDown (KeyCode.L))
        {
          if (CurrentAmmo > TrueMaxAmmo)
          {
          CurrentAmmo = TrueMaxAmmo;
          }
          if (CurrentAmmo <= TrueMaxAmmo)
          {
          CurrentAmmo = CurrentAmmo;
          }
          ModAPI.Notify("Infinity Ammo <color=red> OFF");
          ViewID = 1;
        }

        if (Input.GetKeyDown (KeyCode.H))
        {
          if (CurrentAmmo > TrueMaxAmmo)
          {
          CurrentAmmo = TrueMaxAmmo;
          }
          if (CurrentAmmo <= TrueMaxAmmo)
          {
          CurrentAmmo = CurrentAmmo;
          }
          ModAPI.Notify("Infinity Ammo <color=red> OFF");
          ViewID = 0;
        }

        if (Input.GetKeyDown (KeyCode.I))
        {
          CurrentAmmo = MaxAmmo;
          ModAPI.Notify("Infinity Ammo<color=green> ON");
        }

        Counter += Time.deltaTime;
      }


      void Use()
      {
          if (Counter > FireRate)
          {
              FireGun();
          }
          if (CurrentAmmo == 0)
          {
             if (ViewID == 1)
             {
             ModAPI.Notify("<color=red>NO Ammo");                                                              //<-- Ammo Screen (No Ammo)#1
             }
             NOSound.Play();
          }
      }


      void UseContinuous()
      {
          if (Auto == true)
          {
              if (Counter > FireRate)
              {
                  FireGun();
              }
          }
          if (CurrentAmmo == 0)
          {
             if (ViewID == 1)
             {
             ModAPI.Notify("<color=red>NO Ammo");                                                              //<-- Ammo Screen (No Ammo)#2
             }
             NOSound.Play();
          }
      }

      void FireGun()
      {
          FirearmBehaviour Fire = this.gameObject.GetComponent<FirearmBehaviour>();

          if (CurrentAmmo > 0 && Counter > FireRate)
          {
              Counter = 0f;
              CurrentAmmo -= Shots;
              Fire.Shoot();
              Counter = 0f;

              if (CurrentAmmo < TrueMaxAmmo && CurrentAmmo > 0 && Counter == 0f && ViewID == 1)                //<-- Ammo Screen
              {
                ModAPI.Notify(CurrentAmmo + "<color=black>s</color>/<color=black>s</color>" + TrueMaxAmmo);
              }
          }
      }
   }
}
