using UnityEngine;
using UnityEngine.Events;

namespace Modern
{
  public class ProjectilesBehaviourV1_1 : MonoBehaviour
  {
      public int MaxAmmo = 999999;
      public int TrueMaxAmmo;
      public int CurrentAmmo;
      public int ViewID = 0;
      public int Shots = 1;
      public AudioSource ReloadSound;
      public AudioSource NOSound;

      void Awake()                                                                                               //<-- Start Settings
      {
        ReloadSound = gameObject.AddComponent<AudioSource>();
        NOSound = gameObject.AddComponent<AudioSource>();

        ReloadSound.volume = 4f;
        ReloadSound.minDistance = 15f;
        ReloadSound.spatialBlend = 1f;
        ReloadSound.dopplerLevel = 0.0f;

        NOSound.volume = 2.5f;
        NOSound.minDistance = 15f;
        NOSound.spatialBlend = 1f;
        NOSound.dopplerLevel = 0.0f;
        NOSound.clip = ModAPI.LoadSound("Sounds/Featured/no sound.mp3");

        if (TrueMaxAmmo <= 0)
        {
            TrueMaxAmmo = 30;
        }
        if (CurrentAmmo < 0)
        {
            CurrentAmmo = 0;
        }
        CurrentAmmo = MaxAmmo;
        ViewID = 0;
        Shots = 1;
        Buttons();
      }

      void Buttons()                                                                                            //<-- Menu Buttons
      {
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("limited ammo", "<color=red>Limited Ammo", "<color=red>Makes them limited. To make it with each gun on spawn Press [L]", () =>
          {
              if (CurrentAmmo > TrueMaxAmmo)
              {
              CurrentAmmo = TrueMaxAmmo;
              }
              if (CurrentAmmo <= TrueMaxAmmo)
              {
              CurrentAmmo = CurrentAmmo;
              }
              ModAPI.Notify("Infinity Ammo <color=red> OFF");
              ViewID = 1;
          }));
          this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("limited ammo hidden", "<color=white>Limited Ammo HIDE", "<color=white>The same limited amount of ammo only without pop-up messages. Useful if you are shooting a video or film. To make it with each gun on spawn Press [H]", () =>
            {
                if (CurrentAmmo > TrueMaxAmmo)
                {
                CurrentAmmo = TrueMaxAmmo;
                }
                if (CurrentAmmo <= TrueMaxAmmo)
                {
                CurrentAmmo = CurrentAmmo;
                }
                ModAPI.Notify("Infinity Ammo <color=red> OFF");
                ViewID = 0;
            }));
          this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("ammo int", "<color=red>Show Ammo", "<color=red>Shows your current ammo.", () =>
            {
                if (CurrentAmmo <= TrueMaxAmmo & CurrentAmmo > 0)
                {
                  ModAPI.Notify("<color=green>Ammo:</color><color=black>s</color>" + CurrentAmmo + "<color=black>s</color>/<color=black>s</color>" + TrueMaxAmmo);
                }
                if (CurrentAmmo > TrueMaxAmmo)
                {
                  ModAPI.Notify("<color=green>Ammo:</color><color=black>s</color>" + TrueMaxAmmo + "<color=black>s</color>/<color=black>s</color>" + TrueMaxAmmo);
                }
                if (CurrentAmmo == 0)
                {
                  ModAPI.Notify("<color=green>NO Ammo");
                }
            }));
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("ammo reload", "<color=white>Reload Ammo", "<color=white>Reload if no ammo. To reload each gun on spawn Press [R]", () =>
          {
              if (CurrentAmmo <= TrueMaxAmmo)
              {
              CurrentAmmo = TrueMaxAmmo;
              }
              if (CurrentAmmo > TrueMaxAmmo)
              {
              CurrentAmmo = MaxAmmo;
              }
              ReloadSound.Play();

              ModAPI.Notify("<color=#FABF7E>Reloaded");

              gameObject.GetComponent<ProjectileLauncherBehaviour>().enabled = true;
              gameObject.GetComponent<JavelinBehaviour>().enabled = true;
          }));
        this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("infinity ammo", "<color=red>Infinity Ammo", "<color=red>Makes them infinity. To make it with each gun on spawn Press [I]", () =>
          {
              CurrentAmmo = MaxAmmo;
              ModAPI.Notify("Infinity Ammo<color=green> ON");

              gameObject.GetComponent<ProjectileLauncherBehaviour>().enabled = true;
              gameObject.GetComponent<JavelinBehaviour>().enabled = true;
          }));
      }

      void Update()                                                                                               //<-- Ammo Settings
      {
        if (CurrentAmmo < 1)
      	{
      		if (gameObject.GetComponent<ProjectileLauncherBehaviour>() == false)
      		{
      		  gameObject.GetComponent<RocketLauncherBehaviour>().enabled = false;
      	    CurrentAmmo = 0;
      		}

      		if (gameObject.GetComponent<ProjectileLauncherBehaviour>() == true)
      		{
      		   gameObject.GetComponent<ProjectileLauncherBehaviour>().enabled = false;
      	     CurrentAmmo = 0;
      		}

      	    if (gameObject.GetComponent<JavelinBehaviour>() == true)
      	    {
      		   gameObject.GetComponent<JavelinBehaviour>().enabled = false;
      		   gameObject.GetComponent<ProjectileLauncherBehaviour>().enabled = false;
      		   gameObject.GetComponent<UseEventTrigger>().enabled = false;
      	    }
      	 }

         if (Input.GetKeyDown (KeyCode.R))
         {
           if (CurrentAmmo <= TrueMaxAmmo)
           {
           CurrentAmmo = TrueMaxAmmo;
           }
           if (CurrentAmmo > TrueMaxAmmo)
           {
           CurrentAmmo = MaxAmmo;
           }
           ModAPI.Notify("<color=#FABF7E>Reloaded");
           ReloadSound.Play();

           gameObject.GetComponent<ProjectileLauncherBehaviour>().enabled = true;
           gameObject.GetComponent<RocketLauncherBehaviour>().enabled = true;
           gameObject.GetComponent<JavelinBehaviour>().enabled = true;
         }

         if (Input.GetKeyDown (KeyCode.L))
         {
           if (CurrentAmmo > TrueMaxAmmo)
           {
           CurrentAmmo = TrueMaxAmmo;
           }
           if (CurrentAmmo <= TrueMaxAmmo)
           {
           CurrentAmmo = CurrentAmmo;
           }
           ModAPI.Notify("Infinity Ammo <color=red> OFF");
           ViewID = 1;
         }

         if (Input.GetKeyDown (KeyCode.H))
         {
           if (CurrentAmmo > TrueMaxAmmo)
           {
           CurrentAmmo = TrueMaxAmmo;
           }
           if (CurrentAmmo <= TrueMaxAmmo)
           {
           CurrentAmmo = CurrentAmmo;
           }
           ModAPI.Notify("Infinity Ammo <color=red> OFF");
           ViewID = 0;
         }

         if (Input.GetKeyDown (KeyCode.I))
         {
           CurrentAmmo = MaxAmmo;
           ModAPI.Notify("Infinity Ammo<color=green> ON");

           gameObject.GetComponent<ProjectileLauncherBehaviour>().enabled = true;
           gameObject.GetComponent<RocketLauncherBehaviour>().enabled = true;
           gameObject.GetComponent<JavelinBehaviour>().enabled = true;
         }
      }


      void Use()                                                                                                  //<-- Ammo Screen
      {
       if (CurrentAmmo == 0)
       {
         if (ViewID == 1)
         {
         ModAPI.Notify("<color=red>NO Ammo");
         }
     	   NOSound.Play();
       }
       if (CurrentAmmo > 0)
       {
         CurrentAmmo -= Shots;
       }
       if (CurrentAmmo < TrueMaxAmmo && CurrentAmmo > 0 && ViewID == 1)
       {
         ModAPI.Notify(CurrentAmmo + "<color=black>s</color>/<color=black>s</color>" + TrueMaxAmmo);
       }
      }
   }
}
