using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;
using System.Collections;
using UnityEngine.Events;

namespace Modern
{
    public class Modern
    {
        public static void Main()
        {
          CategoryBuilder.Create("<color=green>Modern</color> Firearms", "Weapons from 1980s to our days.", ModAPI.LoadSprite("categoryicon.png"));


          ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                   NameOverride = "<color=green>Beretta 92</color> <color=#FABF7E>(Italy)</color>",
                   NameToOrderByOverride = "A - FA",
                   DescriptionOverride = "The legendary Italian gun is characterized by high reliability and brutal appearance. \n<color=green>Ammo: <color=#FABF7E>15 <color=black>12characterssss <color=green>Damage: <color=#FABF7E>16 \n<color=green>Fire Rate: <color=#FABF7E>300 <color=black>8characters <color=green>Mass: <color=#FABF7E>1",
                   CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                   ThumbnailOverride = ModAPI.LoadSprite("Icons/beretta icon.png"),
                   AfterSpawn = (Instance) =>
                   {
                     ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                     var Weapon = Instance.transform;
                     var Cover = new GameObject("Cover");
                     Cover.transform.SetParent(Weapon);
                     Cover.transform.localPosition = new Vector3(0f, 0f);
                     Cover.transform.rotation = Weapon.rotation;
                     Cover.transform.localScale = new Vector3(1f, 1f);
                     var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                     CoverSprite.sprite = ModAPI.LoadSprite("Pistols/beretta_cover.png", 2);
                     CoverSprite.sortingOrder = 7;

                       ModAPI.KeepExtraObjects();

                       var PistolSlide = Instance.transform.Find("Slide");
                       PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/beretta_slide.png", 2);

                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/beretta_collider.png", 22);
                       foreach (var c in Instance.GetComponents<Collider2D>())
                       {
                           GameObject.Destroy(c);
                       }
                       Instance.FixColliders();
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/beretta.png", 2);

                       Instance.AddComponent<AmmoBehaviourV1_3>();
                       var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                       Ammo.TrueMaxAmmo = 15;
                       Ammo.SwitchID = 1;
                       Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/beretta_reload sound.mp3");

                       var firearm = Instance.GetComponent<FirearmBehaviour>();
                       firearm.BulletsPerShot = 1;
                       firearm.AutomaticFireInterval = 0.2f;
                       firearm.barrelPosition = new Vector2(0.12f, 0.09f);
                       firearm.ShotSounds = new AudioClip[]
                       {
                             ModAPI.LoadSound("Sounds/beretta sound.mp3"),
                       };

                       Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                       customCartridge.name = "9mm";
                       customCartridge.Damage = 15.62f;
                       customCartridge.Recoil = 0.75f;
                       customCartridge.ImpactForce = 0.65f;
                       customCartridge.StartSpeed = 4f;
                       firearm.Cartridge = customCartridge;

                       var phys = Instance.GetComponent<PhysicalBehaviour>();
                       Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                   }
               }
           );

           ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "<color=green>FN Five-seveN</color> <color=#FABF7E>(Belgium)</color>",
                    NameToOrderByOverride = "A - FA",
                    DescriptionOverride = "Accurate and capacious pistol with submachine gun caliber. \n<color=green>Ammo: <color=#FABF7E>20 <color=black>12characterssss <color=green>Damage: <color=#FABF7E>15 \n<color=green>Fire Rate: <color=#FABF7E>600 <color=black>8characters <color=green>Mass: <color=#FABF7E>0.7",
                    CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/fiveseven icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                      ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                      var Weapon = Instance.transform;
                      var Cover = new GameObject("Cover");
                      Cover.transform.SetParent(Weapon);
                      Cover.transform.localPosition = new Vector3(0f, 0f);
                      Cover.transform.rotation = Weapon.rotation;
                      Cover.transform.localScale = new Vector3(1f, 1f);
                      var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                      CoverSprite.sprite = ModAPI.LoadSprite("Pistols/five_seven_cover.png", 2);
                      CoverSprite.sortingOrder = 7;

                        ModAPI.KeepExtraObjects();

                        var PistolSlide = Instance.transform.Find("Slide");
                        PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/five_seven_slide.png", 2);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/five_seven_collider.png", 22);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/five_seven.png", 2);

                        Instance.AddComponent<AmmoBehaviourV1_3>();
                        var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                        Ammo.TrueMaxAmmo = 20;
                        Ammo.SwitchID = 1;
                        Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/five_seven_reload sound.mp3");

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.BulletsPerShot = 1;
                        firearm.AutomaticFireInterval = 0.1f;
                        firearm.barrelPosition = new Vector2(0.12f, 0.09f);
                        firearm.ShotSounds = new AudioClip[]
                        {
                              ModAPI.LoadSound("Sounds/five_seven sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5,7x28mm";
                        customCartridge.Damage = 15f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.5f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Cartridge = customCartridge;

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.075f;
                    }
                }
            );

            ModAPI.Register(
                 new Modification()
                 {
                     OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                     NameOverride = "<color=green>Glock 23</color> <color=#FABF7E>(Austria)</color>",
                     NameToOrderByOverride = "A - FA",
                     DescriptionOverride = "A compact continuation of the Glock 17 with a magazine reduced to 13 rounds, but with a larger caliber. \n<color=green>Ammo: <color=#FABF7E>13 <color=black>12characterssss <color=green>Damage: <color=#FABF7E>17 \n<color=green>Fire Rate: <color=#FABF7E>400 <color=black>8characters <color=green>Mass: <color=#FABF7E>0.9",
                     CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                     ThumbnailOverride = ModAPI.LoadSprite("Icons/glock23 icon.png"),
                     AfterSpawn = (Instance) =>
                     {
                       ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                       var Weapon = Instance.transform;
                       var Cover = new GameObject("Cover");
                       Cover.transform.SetParent(Weapon);
                       Cover.transform.localPosition = new Vector3(0f, 0f);
                       Cover.transform.rotation = Weapon.rotation;
                       Cover.transform.localScale = new Vector3(1f, 1f);
                       var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                       CoverSprite.sprite = ModAPI.LoadSprite("Pistols/glock23_cover.png", 2);
                       CoverSprite.sortingOrder = 7;

                         ModAPI.KeepExtraObjects();

                         var PistolSlide = Instance.transform.Find("Slide");
                         PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/glock23_slide.png", 2);

                         Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/glock23_collider.png", 22);
                         foreach (var c in Instance.GetComponents<Collider2D>())
                         {
                             GameObject.Destroy(c);
                         }
                         Instance.FixColliders();
                         Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/glock23.png", 2);

                         Instance.AddComponent<AmmoBehaviourV1_3>();
                         var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                         Ammo.TrueMaxAmmo = 13;
                         Ammo.SwitchID = 1;
                         Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/glock23_reload sound.mp3");

                         var firearm = Instance.GetComponent<FirearmBehaviour>();
                         firearm.BulletsPerShot = 1;
                         firearm.AutomaticFireInterval = 0.15f;
                         firearm.barrelPosition = new Vector2(0.14f, 0.09f);
                         firearm.ShotSounds = new AudioClip[]
                         {
                               ModAPI.LoadSound("Sounds/glock23 sound.mp3"),
                         };

                         Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                         customCartridge.name = "10mm";
                         customCartridge.Damage = 17.5f;
                         customCartridge.Recoil = 0.5f;
                         customCartridge.ImpactForce = 0.8f;
                         customCartridge.StartSpeed = 4f;
                         firearm.Cartridge = customCartridge;

                         var phys = Instance.GetComponent<PhysicalBehaviour>();
                         Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.09f;
                     }
                 }
             );

             ModAPI.Register(
                  new Modification()
                  {
                      OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                      NameOverride = "<color=green>QSW-06</color> <color=#FABF7E>(China)</color>",
                      NameToOrderByOverride = "A - FA",
                      DescriptionOverride = "A low-power pistol with a silencer. \n<color=green>Ammo: <color=#FABF7E>20 <color=black>12characterssss <color=green>Damage: <color=#FABF7E>14 \n<color=green>Fire Rate: <color=#FABF7E>600 <color=black>8characters <color=green>Mass: <color=#FABF7E>1.2",
                      CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                      ThumbnailOverride = ModAPI.LoadSprite("Icons/qsw06 icon.png"),
                      AfterSpawn = (Instance) =>
                      {
                        ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                        var Weapon = Instance.transform;
                        var Cover = new GameObject("Cover");
                        Cover.transform.SetParent(Weapon);
                        Cover.transform.localPosition = new Vector3(0f, 0f);
                        Cover.transform.rotation = Weapon.rotation;
                        Cover.transform.localScale = new Vector3(1f, 1f);
                        var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                        CoverSprite.sprite = ModAPI.LoadSprite("Pistols/qsw06_cover.png", 2);
                        CoverSprite.sortingOrder = 7;

                          ModAPI.KeepExtraObjects();

                          var PistolSlide = Instance.transform.Find("Slide");
                          PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/qsw06_slide.png", 2);

                          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/qsw06_collider.png", 22);
                          foreach (var c in Instance.GetComponents<Collider2D>())
                          {
                              GameObject.Destroy(c);
                          }
                          Instance.FixColliders();
                          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/qsw06.png", 2);

                          Instance.AddComponent<AmmoBehaviourV1_3>();
                          var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                          Ammo.TrueMaxAmmo = 20;
                          Ammo.SwitchID = 1;
                          Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/qsw06_reload sound.mp3");

                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                          firearm.BulletsPerShot = 1;
                          firearm.AutomaticFireInterval = 0.1f;
                          firearm.barrelPosition = new Vector2(0.5f, 0.075f);
                          firearm.ShotSounds = new AudioClip[]
                          {
                                ModAPI.LoadSound("Sounds/qsw06 sound.mp3"),
                          };

                          Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                          customCartridge.name = "5,8x21mm";
                          customCartridge.Damage = 14f;
                          customCartridge.Recoil = 0.4f;
                          customCartridge.ImpactForce = 0.55f;
                          customCartridge.StartSpeed = 4f;
                          firearm.Cartridge = customCartridge;

                          var phys = Instance.GetComponent<PhysicalBehaviour>();
                          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.12f;
                      }
                  }
              );

              ModAPI.Register(
                   new Modification()
                   {
                       OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                       NameOverride = "<color=green>RSH-12</color> <color=#FABF7E>(Russia)</color>",
                       NameToOrderByOverride = "A - FA",
                       DescriptionOverride = "One of the most powerful revolvers in the world. Not very convenient for playing Russian Roulette because it has only 5 rounds. \n<color=green>Ammo: <color=#FABF7E>5 <color=black>12characterssss <color=green>Damage: <color=#FABF7E>40 \n<color=green>Fire Rate: <color=#FABF7E>300 <color=black>8character <color=green>Mass: <color=#FABF7E>2.2",
                       CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                       ThumbnailOverride = ModAPI.LoadSprite("Icons/rsh12 icon.png"),
                       AfterSpawn = (Instance) =>
                       {
                         ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                         var Weapon = Instance.transform;
                         var Cover = new GameObject("Cover");
                         Cover.transform.SetParent(Weapon);
                         Cover.transform.localPosition = new Vector3(0f, 0f);
                         Cover.transform.rotation = Weapon.rotation;
                         Cover.transform.localScale = new Vector3(1f, 1f);
                         var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                         CoverSprite.sprite = ModAPI.LoadSprite("Pistols/_cover.png", 2);
                         CoverSprite.sortingOrder = 7;

                           ModAPI.KeepExtraObjects();

                           var PistolSlide = Instance.transform.Find("Slide");
                           PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/_slide.png", 2);

                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/rsh12_collider.png", 22);
                           foreach (var c in Instance.GetComponents<Collider2D>())
                           {
                               GameObject.Destroy(c);
                           }
                           Instance.FixColliders();
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/rsh12.png", 2);

                           Instance.AddComponent<AmmoBehaviourV1_3>();
                           var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                           Ammo.TrueMaxAmmo = 5;
                           Ammo.SwitchID = 1;
                           Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/rsh12_reload sound.mp3");

                           var firearm = Instance.GetComponent<FirearmBehaviour>();
                           firearm.BulletsPerShot = 1;
                           firearm.EjectShells = false;
                           firearm.AutomaticFireInterval = 0.2f;
                           firearm.barrelPosition = new Vector2(0.15f, 0.09f);
                           firearm.ShotSounds = new AudioClip[]
                           {
                                 ModAPI.LoadSound("Sounds/rsh12 sound.mp3"),
                           };

                           Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                           customCartridge.name = "12,7×55mm";
                           customCartridge.Damage = 40f;
                           customCartridge.Recoil = 2.5f;
                           customCartridge.ImpactForce = 1.5f;
                           customCartridge.StartSpeed = 12f;
                           firearm.Cartridge = customCartridge;

                           var phys = Instance.GetComponent<PhysicalBehaviour>();
                           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.13f;
                       }
                   }
               );

               ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                        NameOverride = "<color=green>Taurus Curve</color> <color=#FABF7E>(Brazil)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Pocket pistol with an unusual appearance. \n<color=green>Ammo: <color=#FABF7E>6 <color=black>12characterssss <color=green>Damage: <color=#FABF7E>15 \n<color=green>Fire Rate: <color=#FABF7E>400 <color=black>8character <color=green>Mass: <color=#FABF7E>0.4",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/taurus icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Pistols/taurus_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var PistolSlide = Instance.transform.Find("Slide");
                            PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/taurus_slide.png", 2);

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/taurus_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/taurus.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 6;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/taurus_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.AutomaticFireInterval = 0.15f;
                            firearm.barrelPosition = new Vector2(0.05f, 0.05f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/taurus sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "9x17mm";
                            customCartridge.Damage = 15f;
                            customCartridge.Recoil = 0.7f;
                            customCartridge.ImpactForce = 0.62f;
                            customCartridge.StartSpeed = 4f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.04f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                        NameOverride = "<color=green>HK UMP</color> <color=#FABF7E>(Germany)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Compensates for a low rate of fire with a high stopping effect. \n<color=green>Ammo: <color=#FABF7E>25 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>26 \n<color=green>Fire Rate: <color=#FABF7E>600 <color=black>8character <color=green>Mass: <color=#FABF7E>2.5",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/umphk icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("SMGs/umphk_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var PistolSlide = Instance.transform.Find("Slide");
                            PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/umphk_slide.png", 2);

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/umphk_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/umphk.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 25;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/umphk_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.1f;
                            firearm.barrelPosition = new Vector2(0.49f, 0.11f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/umphk sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "45 APC.";
                            customCartridge.Damage = 26f;
                            customCartridge.Recoil = 0.75f;
                            customCartridge.ImpactForce = 0.2f;
                            customCartridge.StartSpeed = 4f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                        NameOverride = "<color=green>Kriss Vector</color> <color=#FABF7E>(USA)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Created according to the original scheme, a submachine gun with great destructive power and, at the same time, acceptable recoil. \n<color=green>Ammo: <color=#FABF7E>30 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>20 \n<color=green>Fire Rate: <color=#FABF7E>1100 <color=black>8characte <color=green>Mass: <color=#FABF7E>2.7",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/kriss icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("SMGs/kriss_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var PistolSlide = Instance.transform.Find("Slide");
                            PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/kriss_slide.png", 2);

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/kriss_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/kriss.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 30;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/kriss_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.054f;
                            firearm.barrelPosition = new Vector2(0.42f, 0.09f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/kriss sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "9mm";
                            customCartridge.Damage = 20f;
                            customCartridge.Recoil = 0.5f;
                            customCartridge.ImpactForce = 0.14f;
                            customCartridge.StartSpeed = 4f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.27f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                        NameOverride = "<color=green>MP5 SMG</color> <color=#FABF7E>(Germany)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "The most popular weapon in its class. Very tactical... \n<color=green>Ammo: <color=#FABF7E>40 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>20 \n<color=green>Fire Rate: <color=#FABF7E>800 <color=black>8characte <color=green>Mass: <color=#FABF7E>2.5",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/mp5 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("SMGs/mp5_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var PistolSlide = Instance.transform.Find("Slide");
                            PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/mp5_slide.png", 2);

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/mp5_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/mp5.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 40;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mp5_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.075f;
                            firearm.barrelPosition = new Vector2(0.51f, 0.14f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/mp5 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "9mm";
                            customCartridge.Damage = 20f;
                            customCartridge.Recoil = 0.5f;
                            customCartridge.ImpactForce = 0.14f;
                            customCartridge.StartSpeed = 4f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                        NameOverride = "<color=green>P90</color> <color=#FABF7E>(Belgium)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Incredibly unusual submachine gun with a compact size and a high rate of fire. \n<color=green>Ammo: <color=#FABF7E>50 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>19 \n<color=green>Fire Rate: <color=#FABF7E>900 <color=black>8character <color=green>Mass: <color=#FABF7E>3",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/p90 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("SMGs/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var PistolSlide = Instance.transform.Find("Slide");
                            PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/p90_slide.png", 2);

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/p90_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/p90.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 50;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/p90_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.0666f;
                            firearm.barrelPosition = new Vector2(0.22f, 0.06f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/p90 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,7x28mm";
                            customCartridge.Damage = 18.75f;
                            customCartridge.Recoil = 0.5f;
                            customCartridge.ImpactForce = 0.14f;
                            customCartridge.StartSpeed = 4f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                        NameOverride = "<color=green>PP-19 Bizon</color> <color=#FABF7E>(Russia)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "One of the most capacious submachine guns and all thanks to the auger magazine, which costs three times more than the weapon itself. \n<color=green>Ammo: <color=#FABF7E>64 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>20 \n<color=green>Fire Rate: <color=#FABF7E>700 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.3",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/bizon icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("SMGs/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var PistolSlide = Instance.transform.Find("Slide");
                            PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/bizon_slide.png", 2);

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/bizon_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/bizon.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 64;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/bizon_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.086f;
                            firearm.barrelPosition = new Vector2(0.51f, 0.11f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/bizon sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "9mm";
                            customCartridge.Damage = 20f;
                            customCartridge.Recoil = 1f;
                            customCartridge.ImpactForce = 0.14f;
                            customCartridge.StartSpeed = 4f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.33f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                        NameOverride = "<color=green>Scorpion EVO</color> <color=#FABF7E>(Czech)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Compact and very fast-firing pistol for self-defense. \n<color=green>Ammo: <color=#FABF7E>20 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>20 \n<color=green>Fire Rate: <color=#FABF7E>1100 <color=black>8characte <color=green>Mass: <color=#FABF7E>2.8",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/scorpion icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("SMGs/scorpion_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var PistolSlide = Instance.transform.Find("Slide");
                            PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/scorpion_slide.png", 2);

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/scorpion_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMGs/scorpion.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 20;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/scorpion_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.054f;
                            firearm.barrelPosition = new Vector2(0.41f, 0.09f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/scorpion sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "9mm";
                            customCartridge.Damage = 20f;
                            customCartridge.Recoil = 1f;
                            customCartridge.ImpactForce = 0.14f;
                            customCartridge.StartSpeed = 4f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.28f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>AK-12 Kalashnikov</color> <color=#FABF7E>(Russia)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A modernized version of the obsolete AK-74 with a plastic handguard, red dot sight and other goodies. \n<color=green>Ammo: <color=#FABF7E>30 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>32 \n<color=green>Fire Rate: <color=#FABF7E>600 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.8",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/ak12 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Assault Rifles/ak12_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/ak12_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/ak12_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/ak12.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 30;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/ak12_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.1f;
                            firearm.barrelPosition = new Vector2(0.57f, 0.09f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/ak12 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm";
                            customCartridge.Damage = 32f;
                            customCartridge.Recoil = 1f;
                            customCartridge.ImpactForce = 0.1f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.26f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>Famas G2</color> <color=#FABF7E>(France)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "French bullpup assault rifle. \n<color=green>Ammo: <color=#FABF7E>30 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>29 \n<color=green>Fire Rate: <color=#FABF7E>900 <color=black>8characte <color=green>Mass: <color=#FABF7E>4",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/famas icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Assault Rifles/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/famas_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/famas_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/famas.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 30;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/famas_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.0666f;
                            firearm.barrelPosition = new Vector2(0.22f, 0.06f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/famas sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm NATO";
                            customCartridge.Damage = 29f;
                            customCartridge.Recoil = 0.7f;
                            customCartridge.ImpactForce = 0.1f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.28f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>FN SCAR-H</color> <color=#FABF7E>(USA / Belgium)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Heavy rifle with no less heavy bullets. \n<color=green>Ammo: <color=#FABF7E>20 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>38 \n<color=green>Fire Rate: <color=#FABF7E>625 <color=black>8characte <color=green>Mass: <color=#FABF7E>4",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/scarh icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Assault Rifles/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/scarh_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/scarh_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/scarh.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 20;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/scarh_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.096f;
                            firearm.barrelPosition = new Vector2(0.57f, 0.12f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/scarh sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "7,56x51mm NATO";
                            customCartridge.Damage = 38f;
                            customCartridge.Recoil = 1.25f;
                            customCartridge.ImpactForce = 0.15f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.28f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>FN SCAR-L</color> <color=#FABF7E>(USA / Belgium)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A lighter version of the SCAR-H with a faster rate of fire and classic ammo. \n<color=green>Ammo: <color=#FABF7E>30 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>29 \n<color=green>Fire Rate: <color=#FABF7E>650 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.7",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/scarl icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Assault Rifles/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/scarl_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/scarl_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/scarl.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 30;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/scarl_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.092f;
                            firearm.barrelPosition = new Vector2(0.44f, 0.12f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/scarl sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm NATO";
                            customCartridge.Damage = 29f;
                            customCartridge.Recoil = 0.7f;
                            customCartridge.ImpactForce = 0.1f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.27f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>HK G36c</color> <color=#FABF7E>(Germany)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A shortened G36 assault rifle with good accuracy and low weight. And yes, it's George 36, I guess... \n<color=green>Ammo: <color=#FABF7E>30 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>26 \n<color=green>Fire Rate: <color=#FABF7E>750 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.3",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/g36c icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Assault Rifles/g36c_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/g36c_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/g36c_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/g36c.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 30;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/g36c_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.08f;
                            firearm.barrelPosition = new Vector2(0.31f, 0.12f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/g36c sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm NATO";
                            customCartridge.Damage = 26f;
                            customCartridge.Recoil = 0.65f;
                            customCartridge.ImpactForce = 0.1f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.24f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>M4A1 Carbine</color> <color=#FABF7E>(USA)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A very tactical carbine with a high rate of fire and low weight. \n<color=green>Ammo: <color=#FABF7E>30 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>29 \n<color=green>Fire Rate: <color=#FABF7E>700 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.4",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/m4a1 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Assault Rifles/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/m4a1_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/m4a1_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/m4a1.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 30;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m4a1_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.085f;
                            firearm.barrelPosition = new Vector2(0.51f, 0.14f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/m4a1 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm NATO";
                            customCartridge.Damage = 29f;
                            customCartridge.Recoil = 0.7f;
                            customCartridge.ImpactForce = 0.1f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.24f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>XM29 OICW</color> <color=#FABF7E>(USA / Germany)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A complex of small arms consisting of a sight (the size of a telescope), a flashlight and the machine itself. \n<color=green>Ammo: <color=#FABF7E>30 <color=black>12charactersss <color=green>Damage: <color=#FABF7E>29 \n<color=green>Fire Rate: <color=#FABF7E>800 <color=black>8characte <color=green>Mass: <color=#FABF7E>7.8",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/xm29 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Assault Rifles/xm29_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/xm29_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/xm29_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assault Rifles/xm29.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 30;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/xm29_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.075f;
                            firearm.barrelPosition = new Vector2(0.43f, 0.12f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/xm29 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm NATO";
                            customCartridge.Damage = 29f;
                            customCartridge.Recoil = 0.7f;
                            customCartridge.ImpactForce = 0.1f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.54f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>HK MG36</color> <color=#FABF7E>(Germany)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "The well-known G36 assault rifle converted into a machine gun with a drum magazine. Adopted all the best properties from the parent. \n<color=green>Ammo: <color=#FABF7E>100 <color=black>12characterss <color=green>Damage: <color=#FABF7E>32 \n<color=green>Fire Rate: <color=#FABF7E>750 <color=black>8characte <color=green>Mass: <color=#FABF7E>4.5",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/mg36 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Machine Guns/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Machine Guns/_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/mg36_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Machine Guns/mg36.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 100;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mg36_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.08f;
                            firearm.barrelPosition = new Vector2(0.75f, 0.12f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/mg36 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm NATO";
                            customCartridge.Damage = 32f;
                            customCartridge.Recoil = 0.9f;
                            customCartridge.ImpactForce = 0.12f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.34f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>M249 SAW</color> <color=#FABF7E>(USA)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Heavy tactical American machine gun. \n<color=green>Ammo: <color=#FABF7E>150 <color=black>12characterss <color=green>Damage: <color=#FABF7E>38 \n<color=green>Fire Rate: <color=#FABF7E>770 <color=black>8characte <color=green>Mass: <color=#FABF7E>8.4",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/m249 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Machine Guns/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Machine Guns/_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/m249_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Machine Guns/m249.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 150;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m249_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.077f;
                            firearm.barrelPosition = new Vector2(0.59f, 0.13f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/m249 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "7,62x51mm NATO";
                            customCartridge.Damage = 38f;
                            customCartridge.Recoil = 1.25f;
                            customCartridge.ImpactForce = 0.15f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.6f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>Negev LMG</color> <color=#FABF7E>(Israel)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Accurate and reliable belt-fed machine gun. In general, kosher! \n<color=green>Ammo: <color=#FABF7E>100 <color=black>12characterss <color=green>Damage: <color=#FABF7E>29 \n<color=green>Fire Rate: <color=#FABF7E>850 <color=black>8characte <color=green>Mass: <color=#FABF7E>7.6",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/negev icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Machine Guns/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Machine Guns/_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/negev_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Machine Guns/negev.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 100;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/negev_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.07f;
                            firearm.barrelPosition = new Vector2(0.58f, 0.17f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/negev sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "5,56x45mm NATO";
                            customCartridge.Damage = 29f;
                            customCartridge.Recoil = 0.7f;
                            customCartridge.ImpactForce = 0.1f;
                            customCartridge.StartSpeed = 8f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.53f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                        NameOverride = "<color=green>AA-12</color> <color=#FABF7E>(USA)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A weighty automatic contraption with no lighter drum magazine. \n<color=green>Ammo: <color=#FABF7E>20 <color=black>12characterss <color=green>Damage: <color=#FABF7E>100 \n<color=green>Fire Rate: <color=#FABF7E>370 <color=black>8characte <color=green>Mass: <color=#FABF7E>6.5",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/aa12 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                            ModAPI.KeepExtraObjects();

                            var ShotgunSlide = Instance.transform.Find("Slide");
                            ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/aa12_slide.png", 2);
                            ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                            ShotgunSlide.localScale = new Vector3(1f, 1f);
                            var ShotgunCover = Instance.transform.Find("Cover");
                            ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/aa12_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/aa12.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 20;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/aa12_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 8;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.16f;
                            firearm.barrelPosition = new Vector2(0.65f, 0.16f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/aa12 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "12";
                            customCartridge.Damage = 12.5f;
                            customCartridge.Recoil = 0.2f;
                            customCartridge.ImpactForce = 0.22f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.46f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                        NameOverride = "<color=green>DP-12</color> <color=#FABF7E>(USA)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Magazine shotgun with a pre-installed tactical pump-action grip. \n<color=green>Ammo: <color=#FABF7E>14 <color=black>12characterss <color=green>Damage: <color=#FABF7E>100 \n<color=green>Fire Rate: <color=#FABF7E>600 <color=black>8characte <color=green>Mass: <color=#FABF7E>4.2",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/dp12 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                            ModAPI.KeepExtraObjects();

                            var ShotgunSlide = Instance.transform.Find("Slide");
                            ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/dp12_slide.png", 2);
                            ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                            ShotgunSlide.localScale = new Vector3(1f, 1f);
                            var ShotgunCover = Instance.transform.Find("Cover");
                            ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/dp12_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/dp12.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 14;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/dp12_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 8;
                            firearm.AutomaticFireInterval = 0.1f;
                            firearm.barrelPosition = new Vector2(0.48f, 0.2f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/dp12 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "12";
                            customCartridge.Damage = 12.5f;
                            customCartridge.Recoil = 0.38f;
                            customCartridge.ImpactForce = 0.27f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                        NameOverride = "<color=green>Benelli M2</color> <color=#FABF7E>(Italy)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "High quality self-loading hunting rifle. \n<color=green>Ammo: <color=#FABF7E>8 <color=black>12characterss <color=green>Damage: <color=#FABF7E>100 \n<color=green>Fire Rate: <color=#FABF7E>240 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.5",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/beneli icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                            ModAPI.KeepExtraObjects();

                            var ShotgunSlide = Instance.transform.Find("Slide");
                            ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/_slide.png", 2);
                            ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                            ShotgunSlide.localScale = new Vector3(1f, 1f);
                            var ShotgunCover = Instance.transform.Find("Cover");
                            ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/beneli_collider.png", 17);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/beneli.png", 1.5f);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 8;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/beneli_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 8;
                            firearm.AutomaticFireInterval = 0.4f;
                            firearm.barrelPosition = new Vector2(0.67f, 0.12f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/beneli sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "12";
                            customCartridge.Damage = 12.5f;
                            customCartridge.Recoil = 0.2f;
                            customCartridge.ImpactForce = 0.22f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                        NameOverride = "<color=green>Saiga 12</color> <color=#FABF7E>(Russia)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A hunting carbine based on the AK-47. It has a box magazine and a high rate of fire. \n<color=green>Ammo: <color=#FABF7E>8 <color=black>12characterss <color=green>Damage: <color=#FABF7E>100 \n<color=green>Fire Rate: <color=#FABF7E>600 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.6",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/saiga icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                            ModAPI.KeepExtraObjects();

                            var ShotgunSlide = Instance.transform.Find("Slide");
                            ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/_slide.png", 2);
                            ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                            ShotgunSlide.localScale = new Vector3(1f, 1f);
                            var ShotgunCover = Instance.transform.Find("Cover");
                            ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/saiga_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/saiga.png", 2f);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 8;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/saiga_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 8;
                            firearm.AutomaticFireInterval = 0.1f;
                            firearm.barrelPosition = new Vector2(0.8f, 0.14f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/saiga sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "12";
                            customCartridge.Damage = 12.5f;
                            customCartridge.Recoil = 0.2f;
                            customCartridge.ImpactForce = 0.22f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.26f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                        NameOverride = "<color=green>STF-12</color> <color=#FABF7E>(Italy)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Incredibly small and incredibly lethal shotgun for close range. \n<color=green>Ammo: <color=#FABF7E>5 <color=black>12characterss <color=green>Damage: <color=#FABF7E>100 \n<color=green>Fire Rate: <color=#FABF7E>100 <color=black>8characte <color=green>Mass: <color=#FABF7E>3.4",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/stf12 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                            ModAPI.KeepExtraObjects();

                            var ShotgunSlide = Instance.transform.Find("Slide");
                            ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/stf12_slide.png", 2);
                            ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                            ShotgunSlide.localScale = new Vector3(1f, 1f);
                            var ShotgunCover = Instance.transform.Find("Cover");
                            ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/stf12_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/stf12.png", 2f);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 5;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/stf12_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 8;
                            firearm.AutomaticFireInterval = 0.6f;
                            firearm.barrelPosition = new Vector2(0.48f, 0.16f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/stf12 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "12";
                            customCartridge.Damage = 12.5f;
                            customCartridge.Recoil = 0.2f;
                            customCartridge.ImpactForce = 0.22f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.24f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>Barrett M99</color> <color=#FABF7E>(USA)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A large-caliber anti-material rifle is designed to make democracy with a large caliber. \n<color=green>Ammo: <color=#FABF7E>1 <color=black>12characterss <color=green>Damage: <color=#FABF7E>150 \n<color=green>Fire Rate: <color=#FABF7E>45 <color=black>8characte <color=green>Mass: <color=#FABF7E>11",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/m99 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Rifles/m99_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/m99_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/m99_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/m99.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 1;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m99_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.AutomaticFireInterval = 1.5f;
                            firearm.barrelPosition = new Vector2(1f, 0.145f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/m99 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "12,7×99mm";
                            customCartridge.Damage = 150f;
                            customCartridge.Recoil = 4f;
                            customCartridge.ImpactForce = 2f;
                            customCartridge.StartSpeed = 40f;
                            customCartridge.PenetrationRandomAngleMultiplier = 0.1f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.55f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>G3SG1</color> <color=#FABF7E>(Germany)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "A modified version of the earlier G3 assault rifle designed for single and automatic sniper shooting at close range. I like to call him George. \n<color=green>Ammo: <color=#FABF7E>20 <color=black>12characterss <color=green>Damage: <color=#FABF7E>44 \n<color=green>Fire Rate: <color=#FABF7E>400 <color=black>8characte <color=green>Mass: <color=#FABF7E>4.2",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/g3sg1 icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Rifles/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/g3sg1_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/g3sg1_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/g3sg1.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 20;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/g3sg1_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.Automatic = true;
                            firearm.AutomaticFireInterval = 0.17f;
                            firearm.barrelPosition = new Vector2(0.8f, 0.12f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/g3sg1 sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "7,62×51mm NATO";
                            customCartridge.Damage = 44f;
                            customCartridge.Recoil = 1.5f;
                            customCartridge.ImpactForce = 0.15f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>Steyr Scout</color> <color=#FABF7E>(Austria)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Hunting carbine store-bought in a plastic stock. \n<color=green>Ammo: <color=#FABF7E>5 <color=black>12characterss <color=green>Damage: <color=#FABF7E>50 \n<color=green>Fire Rate: <color=#FABF7E>60 <color=black>8characte <color=green>Mass: <color=#FABF7E>4",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/scout icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Rifles/scout_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/scout_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/scout_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/scout.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 5;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/scout_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.AutomaticFireInterval = 1f;
                            firearm.barrelPosition = new Vector2(0.68f, 0.06f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/scout sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "7,62×51mm NATO";
                            customCartridge.Damage = 50f;
                            customCartridge.Recoil = 1.5f;
                            customCartridge.ImpactForce = 0.15f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.28f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                        NameOverride = "<color=green>DRD Tactical KIVAARI</color> <color=#FABF7E>(USA)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "Heavy sniper rifle. \n<color=green>Ammo: <color=#FABF7E>10 <color=black>12characterss <color=green>Damage: <color=#FABF7E>60 \n<color=green>Fire Rate: <color=#FABF7E>60 <color=black>8characte <color=green>Mass: <color=#FABF7E>6.2",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/kivaari icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");

                          var Weapon = Instance.transform;
                          var Cover = new GameObject("Cover");
                          Cover.transform.SetParent(Weapon);
                          Cover.transform.localPosition = new Vector3(0f, 0f);
                          Cover.transform.rotation = Weapon.rotation;
                          Cover.transform.localScale = new Vector3(1f, 1f);
                          var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                          CoverSprite.sprite = ModAPI.LoadSprite("Rifles/_cover.png", 2);
                          CoverSprite.sortingOrder = 7;

                            ModAPI.KeepExtraObjects();

                            var RifleSlide = Instance.transform.Find("Slide");
                            RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/kivaari_slide.png", 2);
                            RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/kivaari_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/kivaari.png", 2);

                            Instance.AddComponent<AmmoBehaviourV1_3>();
                            var Ammo = Instance.GetComponent<AmmoBehaviourV1_3>();
                            Ammo.TrueMaxAmmo = 10;
                            Ammo.SwitchID = 1;
                            Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/kivaari_reload sound.mp3");

                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                            firearm.BulletsPerShot = 1;
                            firearm.AutomaticFireInterval = 1f;
                            firearm.barrelPosition = new Vector2(0.95f, 0.14f);
                            firearm.ShotSounds = new AudioClip[]
                            {
                                  ModAPI.LoadSound("Sounds/kivaari sound.mp3"),
                            };

                            Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                            customCartridge.name = "7,62×51mm NATO";
                            customCartridge.Damage = 60f;
                            customCartridge.Recoil = 1.8f;
                            customCartridge.ImpactForce = 0.25f;
                            customCartridge.StartSpeed = 12f;
                            firearm.Cartridge = customCartridge;

                            var phys = Instance.GetComponent<PhysicalBehaviour>();
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.44f;
                        }
                    }
                );

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Grenade Launcher"),
                        NameOverride = "<color=green>Mikor MGL</color> <color=#FABF7E>(South Africa)</color>",
                        NameToOrderByOverride = "A - FA",
                        DescriptionOverride = "This six-shot beast of the apocalypse is exactly what can crush your enemy. \n<color=green>Ammo: <color=#FABF7E>6 <color=black>12characterss <color=green>Damage: <color=#FABF7E>500 \n<color=green>Fire Rate: <color=#FABF7E>- <color=black>8characte <color=green>Mass: <color=#FABF7E>5.3",
                        CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                        ThumbnailOverride = ModAPI.LoadSprite("Icons/mgl icon.png"),
                        AfterSpawn = (Instance) =>
                        {
                          ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");
                            ModAPI.KeepExtraObjects();

                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/mgl_collider.png", 22);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.FixColliders();
                            var firearm = Instance.GetComponent<ProjectileLauncherBehaviour>();
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosive/mgl.png", 2);
                            Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;

                            Instance.AddComponent<ProjectilesBehaviourV1_1>();
                            var Pro = Instance.GetComponent<ProjectilesBehaviourV1_1>();
                            Pro.TrueMaxAmmo = 6;
                            Pro.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mgl_reload sound.mp3");

                            firearm.projectileAsset = ModAPI.FindSpawnable("MGL Grenade <color=#000000>megaturn</color>");
                            firearm.projectileLaunchStrength = 0.27f;

                            firearm.launchSound = ModAPI.LoadSound("Sounds/mgl sound.mp3");
                            firearm.barrelPosition = new Vector2(0.02f, 0.06f);
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.33f;
                        }
                    }
               );

               ModAPI.Register(
                   new Modification()
                   {
                       OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                       NameOverride = "MGL Grenade <color=#000000>megaturn</color>",
                       AfterSpawn = (Instance) =>
                       {
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosive/mgl_grenade.png", 2);

                           Instance.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                           Instance.GetComponent<ExplosiveBehaviour>().Range = 4f;
                           Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0.1f;
                           Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 0.1f;
                           Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 0f;
                           Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0.8f;
                           Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 1f;
                           Instance.FixColliders();
                           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                       }
                   }
               );

               ModAPI.Register(
                   new Modification()
                   {
                       OriginalItem = ModAPI.FindSpawnable("Grenade Launcher"),
                       NameOverride = "<color=green>GM-94</color> <color=#FABF7E>(Russia)</color>",
                       NameToOrderByOverride = "A - FA",
                       DescriptionOverride = "The mechanism of the pump-action shotgun has been increased several times for the use of grenade launcher cartridges. \n<color=green>Ammo: <color=#FABF7E>3 <color=black>12characterss <color=green>Damage: <color=#FABF7E>450 \n<color=green>Fire Rate: <color=#FABF7E>- <color=black>8characte <color=green>Mass: <color=#FABF7E>6",
                       CategoryOverride = ModAPI.FindCategory("<color=green>Modern</color> Firearms"),
                       ThumbnailOverride = ModAPI.LoadSprite("Icons/gm94 icon.png"),
                       AfterSpawn = (Instance) =>
                       {
                         ModAPI.Notify("<color=#FABF7E>Check <color=green>the Context Menu for</color> special functions!</color>");
                           ModAPI.KeepExtraObjects();

                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/gm94_collider.png", 22);
                           foreach (var c in Instance.GetComponents<Collider2D>())
                           {
                               GameObject.Destroy(c);
                           }
                           Instance.FixColliders();
                           var firearm = Instance.GetComponent<ProjectileLauncherBehaviour>();
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosive/gm94.png", 2);
                           Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;

                           Instance.AddComponent<ProjectilesBehaviourV1_1>();
                           var Pro = Instance.GetComponent<ProjectilesBehaviourV1_1>();
                           Pro.TrueMaxAmmo = 3;
                           Pro.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/gm94_reload sound.mp3");

                           firearm.projectileAsset = ModAPI.FindSpawnable("GM-94 Grenade <color=#000000>megaturn</color>");
                           firearm.projectileLaunchStrength = 0.27f;

                           firearm.launchSound = ModAPI.LoadSound("Sounds/gm94 sound.mp3");
                           firearm.barrelPosition = new Vector2(0.22f, 0.08f);
                           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.375f;
                       }
                   }
              );

              ModAPI.Register(
                  new Modification()
                  {
                      OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                      NameOverride = "GM-94 Grenade <color=#000000>megaturn</color>",
                      AfterSpawn = (Instance) =>
                      {
                          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosive/gm94_grenade.png", 2);

                          Instance.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                          Instance.GetComponent<ExplosiveBehaviour>().Range = 4f;
                          Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0.2f;
                          Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 0.1f;
                          Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 0f;
                          Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0.7f;
                          Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 0.8f;
                          Instance.FixColliders();
                          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                      }
                  }
              );
        }
    }
}
